<template>
  <q-page class="text-center">
    <div class="q-pa-md">
      <h2 class="q-mb-none">Welcome!</h2>
      <div>
        <img style="height: 20%; width:20%" src="../assets/login-logo.png" />
      </div>
      <div class="form">
        <q-input
          v-model="user"
          filled
          type="normal"
          label="User"
          @keyup.enter="submit"
        />
        <q-input
          v-model="pass"
          filled
          type="password"
          label="Password"
          @keyup.enter="submit"
        />
      </div>
      <div>
        <q-btn
          class="q-ma-md"
          color="primary"
          text-color="white"
          label="Log In"
          @click="submit"
        />
      </div>
    </div>
  </q-page>
</template>

<script>
import { api } from "boot/axios";
import axios from "axios";
import { mapMutations } from "vuex";

export default {
  name: "LoginPage",
  data() {
    return {
      user: "",
      pass: ""
    };
  },
  methods: {
    ...mapMutations("user", ["login"]),

    async submit(event) {
      //event.preventDefault();
      let errors = [];

      if (!this.user) {
        this.$q.notify({
          color: "red-5",
          textColor: "white",
          icon: "warning",
          message: "Enter username"
        });
        errors.push("No input");
      }
      if (!this.pass) {
        this.$q.notify({
          color: "red-5",
          textColor: "white",
          icon: "warning",
          message: "Enter password"
        });
        errors.push("No password");
      }

      if (errors.length === 0) {
        const loginData = { username: this.user, password: this.pass };
        await api
          .post("/api/user/login", loginData)
          .then(res => {
            if (res.status === 200) {
              console.log(res);
              sessionStorage.setItem("token", res.data.data);
              this.login(res.data.user);
              if (res.data.firstLogin == true)
                this.$router.push("/setpassword");
              else this.$router.push("/home");
            }
            if (res.status === 401) {
              this.$q.notify({
                color: "red-5",
                textColor: "white",
                icon: "warning",
                message: res.message
              });
            }
          })
          .catch(error => {
            // console.log("a intrat pe catch");
            // console.log(error);
            // console.log(error.message);
            this.$q.notify({
              color: "red-5",
              textColor: "white",
              icon: "warning",
              message: error.message
            });
          });
      }
    }
  }
};
</script>

<style scoped>
.q-btn {
}
.header {
  text-align: center;
}
.form {
  margin: auto;
  width: 50%;
  padding: 10px;
}
</style>
